//The definaitions of the methods of a line object

#include <iostream>
#include <GL/glut.h>

#include "line.h"
#include "vector.h"

using namespace std;

void line::setp(vector pIn)		//set the point through which the line passes
{
	p = pIn;
}
void line::setdirection(vector directionIn)	//set the direction through which the line passes
{
	direction = directionIn;
}

void line::setall(vector pIn, vector directionIn)	//set all the line attributes
{
	p = pIn;
	direction = directionIn;
}


void line::draw()			//draw the line
{
	scalar = -5;
	x1.sete1( p.gete1() + (scalar * direction.gete1()) );
	x1.sete2( p.gete2() + (scalar * direction.gete2()) );
	x1.sete3( p.gete3() + (scalar * direction.gete3()) );
	
	scalar = 10;
	x2.sete1( p.gete1() + (scalar * direction.gete1()) );
	x2.sete2( p.gete2() + (scalar * direction.gete2()) );
	x2.sete3( p.gete3() + (scalar * direction.gete3()) );
	
	glBegin(GL_LINES);
		glVertex3f(x1.gete1(), x1.gete2(), x1.gete3() );
		glVertex3f(x2.gete1(), x2.gete2(), x2.gete3() );
	glEnd();
}


void line::draw_from_origin()		//draw the line as a direction vector from the origin
{	
	scalar = 10;
	x2.sete1( p.gete1() + (scalar * direction.gete1()) );
	x2.sete2( p.gete2() + (scalar * direction.gete2()) );
	x2.sete3( p.gete3() + (scalar * direction.gete3()) );
	
	glBegin(GL_LINES);
		glVertex3f(0,0,0 );
		glVertex3f(x2.gete1(), x2.gete2(), x2.gete3() );
	glEnd();
}


void line::draw_intersect(vector a)	//draw the line up to a point, a, where it intersects with a plane
{
	scalar = -5;
	x1.sete1( p.gete1() + (scalar * direction.gete1()) );
	x1.sete2( p.gete2() + (scalar * direction.gete2()) );
	x1.sete3( p.gete3() + (scalar * direction.gete3()) );
	
	x2.sete1(a.gete1());
	x2.sete2(a.gete2());
	x2.sete3(a.gete3());
	
	glBegin(GL_LINES);
		glVertex3f(x1.gete1(), x1.gete2(), x1.gete3() );
		glVertex3f(x2.gete1(), x2.gete2(), x2.gete3() );
	glEnd();
}

void line::draw_intersect_from_origin(vector a)		//draw the line from the origin up to its point of 
{							//intersection with a plane
	
	x2.sete1(a.gete1());
	x2.sete2(a.gete2());
	x2.sete3(a.gete3());
	
	glBegin(GL_LINES);
		glVertex3f( 0,0,0 );
		glVertex3f(x2.gete1(), x2.gete2(), x2.gete3() );
	glEnd();
}


void line::draw_reflect(vector a, vector b)		//draw the reflection of a line
{
	x1.sete1(a.gete1());
	x1.sete2(a.gete2());
	x1.sete3(a.gete3());
	
	scalar = 5;
	x2.sete1( p.gete1() + (scalar * b.gete1()) );
	x2.sete2( p.gete2() + (scalar * b.gete2()) );
	x2.sete3( p.gete3() + (scalar * b.gete3()) );
	
	glBegin(GL_LINES);
		glVertex3f(x1.gete1(), x1.gete2(), x1.gete3() );
		glVertex3f(x2.gete1(), x2.gete2(), x2.gete3() );
	glEnd();
}


vector line::getp()			//return the point through which the line passes
{
	return p;
}


vector line::getDirection()		//return the direction that the line has
{
	return direction;
}


line::line()				//default constructor
{
	p.setall(1,0,0);
	direction.setall(1,0,0);
}



line::line(vector pIn, vector directionIn)	//user defined constructor
{ 
	p = pIn;
	direction = directionIn;
}
