//This is a header file that i have written to import an .obj object
// and store it in the objects i have defined as vectors and polygons. 

#ifndef __OBJ_IMPORT_H__
#define __OBJ_IMPORT_H__

#include <cstdlib>
#include <fstream>
#include <iostream>
#include <string>
#include <GL/glut.h>
#include "polygon.h"
#include "vector.h"

using namespace std;

void open_obj();

vector set_vertex(string);

polygon set_poly(string);

void obj_draw();
void check_limits(int);

void open_obj()
{
	int i=0;
	int j=0;
	
	string line_buffer;

	fstream file_in;
	fstream file_out;

	file_in.open(obj_file.c_str(), ios::in);	//open the .obj file stated within the command 
							//line arguements
	if(!file_in.is_open())
	{
		cout<<"File is not open"<<endl;
		exit(0);
	}

	while(!file_in.eof())				
	{
		getline(file_in, line_buffer);		//get each line from the file

		if(line_buffer[0] == 'v' && line_buffer[1] != 't')	//if the line defines a vertex
		{
			vertex[i] = set_vertex(line_buffer);	//store that vertex in the vertex array 

			check_limits(i);		//check if the vertices are at any extreme
							//of the mesh
			i++;
		}
		else
		if(line_buffer[0] == 'f')		//if the line defines a face of the mesh
		{	
			polys[j] = set_poly(line_buffer);	//store that face in polys array
			planes[j] = find_plane(polys[j]);	//find the plane on which the polygon
								//lies and store that in the
								//corresponding element of the planes array
			j++;
		}
	}
}


vector set_vertex(string line_buffer)		//this function slpits a string from the obj file
{						//that defines a vertex. It takes each component and stores it in
	vector result;				//the corresponding component of a vector.
	int ind = 0;
	string store[3];
	double e1, e2, e3;

	unsigned int string_pos=2;
	unsigned int new_string_pos=2;
	int i,j;

	float str_length = line_buffer.size();

	for(i=0; i<3; i++)	
	{
		if(i!=2)			//if we are retrieving the e1 or e2 component
		{
			new_string_pos = line_buffer.find(" ", new_string_pos);		//find the position of 
											//the spaces in the line 
			
			for(j=string_pos; j<new_string_pos; j++)
			{
				store[ind]+=line_buffer[j];		//store the part of the line that defines 
									//the compnent of the vector in the 
									//string store
			}
		
			ind ++;
			new_string_pos++;
			string_pos=new_string_pos;
		}
		
		else			//if we are retrieving the e3 component, we do not need the position of a 
		{					//space but we nedd the position of the end of the line.
			new_string_pos=str_length;
			
			for(j=string_pos; j<new_string_pos; j++)
			{
				store[ind]+=line_buffer[j];
			}
		}	
	}

	e1 = strtod( store[0].c_str(), NULL );
	e2 = strtod( store[1].c_str(), NULL );
	e3 = strtod( store[2].c_str(), NULL );
	
	result.setall(e1,e2,e3);		//set the result vector to the values of the strings we have just
						//retrived
	return result;	
}


polygon set_poly(string line)			//this fuction is the same as above except it performs the 
{						//operation for a string that holds information about a face
	polygon result;				//on the mesh. It stores this information in a polygon object
	int ind = 0;				//that is then returned.
	string store;
	int vert_num[3];
	vector v1, v2, v3;

	unsigned int space_pos=0;
	unsigned int slash_pos=0;
	int i,j;

	for(i=0; i<3; i++)	
	{

		space_pos = line.find(" ", space_pos);
		
		slash_pos = line.find("/", slash_pos);

		for(j=space_pos; j<slash_pos; j++)
		{
			store+=line[j];
		}

		space_pos++;
		slash_pos++;

		vert_num[i] = atoi(store.c_str());

		store = "";
	}

	v1 = vertex[vert_num[0]-1];
	v2 = vertex[vert_num[1]-1];
	v3 = vertex[vert_num[2]-1];
	
	result.setall(v1,v2,v3);

	poly_count ++;

	return result;	
}


void obj_draw()			//function for drawing the mesh.
{
	int i;

	for(i=0; i<10000; i++)
	{
		if(polys[i].is_empty())
		break;
		else
		polys[i].draw();
	}
}


void check_limits(int i)			//this function is used to check to see if the vertex concerned
{						//is at any extreme of the model, i.e if it is the top most vertex
	if(vertex[i].gete1()>right_limit)	//or the furthest vertex to the bottom etc.
	right_limit = vertex[i].gete1();
	
	if(vertex[i].gete1()<left_limit)
	left_limit = vertex[i].gete1();

	if(vertex[i].gete2()>upper_limit)
	upper_limit = vertex[i].gete2();

	if(vertex[i].gete2()<lower_limit)
	lower_limit = vertex[i].gete2();
	
	if(vertex[i].gete3()<front_limit)
	front_limit = vertex[i].gete3();

	if(vertex[i].gete3()>back_limit)
	back_limit = vertex[i].gete3();
}

#endif